import { world, system, Vector, EffectTypes } from '@minecraft/server';
import { reloadables } from './reloadables';
import { throwables } from './throwables';
import { emptyThrowables } from './empty_throwables';
import { bullets } from './bullets';



try {

for (const throwItem in throwables) {
	if (!throwables.hasOwnProperty(throwItem)) continue;
	const ammo = throwables[throwItem].ammo;
	if (!ammo) continue;
	const scoreboard = ammo.scoreboard;
	if (!scoreboard) continue;
	try {
		world.scoreboard.addObjective(scoreboard.name, scoreboard.name);
	} catch { }
	scoreboard.id = world.scoreboard.getObjective(scoreboard.name);
    //fire(1, 1, 1, 1, 1, 1, 1);
    //fireAlt(1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1);
}



//for (const bulletItem in bullets) {
//	if (!bullets.hasOwnProperty(bulletItem)) continue;
//	const scoreboard = bullets[bulletItem].scoreboard;
//	scoreboard.id = world.scoreboard.getObjective(scoreboard.name);
//}



for (const reloadItem in reloadables) {
	if (!reloadables.hasOwnProperty(reloadItem)) continue;
	const scoreboard = reloadables[reloadItem].scoreboard;
	const throwObj = throwables[reloadables[reloadItem].reloadedItem];
	if (!scoreboard || !throwObj?.ammo.scoreboard) continue;
	scoreboard.id = throwObj.ammo.scoreboard.id;
	scoreboard.max ??= throwObj.ammo.scoreboard.max;
}


const playersThrowing = {};
const lastShot = {};

world.afterEvents.itemStartUse.subscribe((eventData) => {
    const player = eventData.source;
	var item = eventData.itemStack.typeId;

    if(item.substring(0,16) == "yes:remington870") {
        item = "yes:remington870";
    }
    else if(item.substring(0,12) == "yes:ithaca37") {
        item = "yes:ithaca37";
    }
    else if(item.substring(0,10) == "yes:mgl105") {
        item = "yes:mgl105";
    }
    if (!throwables[item] && !emptyThrowables[item]) return;

    if(emptyThrowables[item]) {
       //if((player.runCommand(`testfor @s[tag=reloading]`).successCount == 0 && player.runCommand(`testfor @s[scores={reload_timer=1..}]`).successCount == 1) && (item != "yes:empty_remington870" && item != "yes:empty_ithaca37")) {
       //    player.runCommandAsync(`playsound gun.yes.${item.substring(10,item.length)}_reload @s ~~1~ 1 1 1`);
       //    player.runCommandAsync(`tag @s add reloading`);
       //    console.warn(`gun.yes.${item.substring(10,item.length)}_reload`);
       //}
    }
    else {
        var scoreboardName = throwables[item].ammo.scoreboard.name;
        var score = world.scoreboard.getObjective(scoreboardName).getScore(player);

        var essential         = player.getComponent('minecraft:inventory').container;
        var itemSlot          = essential.getSlot(player.selectedSlot);
        var itemSelected      = itemSlot.getItem();
        var itemDurability    = itemSelected.getComponent("minecraft:durability");
        var currentDurability   = itemDurability.maxDurability - itemDurability.damage;

        const lowR = throwables[item].low_recoil;
        const midR = throwables[item].mid_recoil;
        const lowC = throwables[item].low_camerashake;
        const midC = throwables[item].mid_camerashake;
        const highC = throwables[item].high_camerashake;
        const loudness = throwables[item].loudness;
        const sound = throwables[item].sound;
        var chargeUp = 0;
        
        var scoreboardName = throwables[item].ammo.scoreboard.name;
        const scoreMax = throwables[item].second_bullet_scoreboard_max;
        const scoreMin = throwables[item].second_bullet_scoreboard_min;

        const quietRange = loudness*(3/4);
        const loudRange = quietRange*(3/5);




        if (throwables[item].projectile == "yes:minigun_bullet" && score == throwables[item].starting_score) {
            //console.warn(`hey`);
            const throwLoop = system.runInterval(() => {
                var score = world.scoreboard.getObjective(scoreboardName).getScore(player);
                const holdDetect = world.scoreboard.getObjective("hold_detector").getScore(player);

                //const recoilScore = player.scoreboard.getScore(world.scoreboard.getObjective("recoil"));                    //testing purposes
                //var recoil;                                                                                                 //testing purposes
                //if(recoilScore >= throwables[item].high_recoil) {                                                           //testing purposes
                //    recoil = "§cHGH";                                                                                       //testing purposes
                //}                                                                                                           //testing purposes
                //else if(recoilScore > throwables[item].low_recoil && recoilScore <= throwables[item].mid_recoil) {          //testing purposes
                //    recoil = "§eMED";                                                                                       //testing purposes
                //}                                                                                                           //testing purposes
                //else {                                                                                                      //testing purposes
                //    recoil = "§aLOW";                                                                                       //testing purposes
                //}                                                                                                   //testing purposes
                if((score >= (scoreMin) && score <= scoreMax && holdDetect >= 5)) {
                    fire(player, item, itemSlot, itemSelected, itemDurability, currentDurability, true);
                    fireAttributes(item, player, recoilScore, lowR, midR, lowC, midC, highC, loudRange, quietRange, loudness, sound);
                    chargeUp++;
                    player.runCommandAsync(`scoreboard players add @s test 1`);   //testing purposes
                }
                else if((chargeUp == 0 || chargeUp == 2) && item == "yes:minigun") {
                        essential         = player.getComponent('minecraft:inventory').container;
                        itemSlot          = essential.getSlot(player.selectedSlot);
                        itemSelected      = itemSlot.getItem();
                        itemDurability    = itemSelected.getComponent("minecraft:durability");
                        currentDurability = itemDurability.maxDurability - itemDurability.damage;
                            itemSelected.getComponent("minecraft:durability").damage = itemDurability.maxDurability - (currentDurability - 1);
                            itemSlot.setItem(itemSelected);
                        chargeUp++;
                        //currentDurability   = itemDurability.maxDurability - itemDurability.damage;
                        //player.runCommandAsync(`say remove + ${chargeUp} + ${currentDurability}`);
                }
                else if((chargeUp == 1 || chargeUp == 3) && item == "yes:minigun") {
                        essential         = player.getComponent('minecraft:inventory').container;
                        itemSlot          = essential.getSlot(player.selectedSlot);
                        itemSelected      = itemSlot.getItem();
                        itemDurability    = itemSelected.getComponent("minecraft:durability");
                        currentDurability   = itemDurability.maxDurability - itemDurability.damage;
                            itemSelected.getComponent("minecraft:durability").damage = itemDurability.maxDurability - (currentDurability + 1);
                            itemSlot.setItem(itemSelected);
                        chargeUp++;
                        //currentDurability   = itemDurability.maxDurability - itemDurability.damage;
                        //player.runCommandAsync(`say add + ${chargeUp} + ${currentDurability}`);
                } 
                score = world.scoreboard.getObjective(scoreboardName).getScore(player);
                if(score == 4) {
                    world.scoreboard.getObjective(scoreboardName).setScore(player, score - 1);
                }
                if (score <= 0 || chargeUp == 4) {
                    delete playersThrowing[eventData.source.id];
                    system.clearRun(throwLoop);
                    chargeUp = 0;
                    return;
                }
            }, 0);
            playersThrowing[player.id] = throwLoop;
            const recoilScore = world.scoreboard.getObjective("recoil").getScore(player);
            const holdDetect = world.scoreboard.getObjective("hold_detector").getScore(player);

            if((holdDetect >= 5)) {
                fire(player, item, itemSlot, itemSelected, itemDurability, currentDurability, true);
                fireAttributes(item, player, recoilScore, lowR, midR, lowC, midC, highC, loudRange, quietRange, loudness, sound);
                player.runCommandAsync(`scoreboard players add @s test 1`);   //testing purposes

                var recoil;                                                                                             //testing purposes
                if(recoilScore >= throwables[item].high_recoil) {                                                       //testing purposes
                    recoil = "§cHGH";                                                                                   //testing purposes
                }                                                                                                       //testing purposes
                else if(recoilScore > throwables[item].low_recoil && recoilScore <= throwables[item].mid_recoil) {      //testing purposes
                    recoil = "§eMED";                                                                                   //testing purposes
                }                                                                                                       //testing purposes
                else {                                                                                                  //testing purposes
                    recoil = "§aLOW";                                                                                   //testing purposes
                }                                                                                                       //testing purposes
                player.runCommandAsync(`tellraw @s {"rawtext":[{"text":"§7recoil: ${recoilScore} (${recoil}§7)"}]}`);   //testing purposes
            }
        }




        else if (throwables[item].projectile == "yes:javelin_missile" && score == throwables[item].starting_score) {
            
            let viewVector = player.getViewDirection();
            const playerRotation = player.getRotation();
            if (playerRotation.x > 30) {
                viewVector.x *= 2.1;
                viewVector.y *= 2.1;
                viewVector.z *= 2.1;
            }
            const { x, y, z } = Vector.add(player.getHeadLocation(), viewVector);
            //player.runCommandAsync(`say ${viewVector.x}`);
            var item = eventData.itemStack.typeId;

            var score = world.scoreboard.getObjective(scoreboardName).getScore(player);
            const recoilScore = world.scoreboard.getObjective("recoil").getScore(player);
            if(player.isSneaking == false) {
                var identifier2;
                if(world.scoreboard.getObjective("identifier2").getScore(player) == undefined) {
                    identifier2 = 0;
                }
                else {
                    identifier2 = world.scoreboard.getObjective("identifier2").getScore(player);
                }
                //try { identifier2 = world.scoreboard.getObjective("identifier2").getScore(player); }
                //catch { identifier2 = 0; }
                if(player.runCommand(`testfor @e[family=javelin_lock,scores={identifier2=${identifier2}},tag=!fired]`).successCount == 0) {
                    player.runCommand(`scoreboard players random @s identifier2 -2000000000 2000000000`);
                    //console.warn(`randomized, ${identifier2}`);
                }
                player.runCommand(`execute as @e[type=yes:javelin_missile,scores={identifier2=${identifier2}}] run scoreboard players add @a[scores={identifier2=${identifier2}}] timer 1`);
                try {var score2 = world.scoreboard.getObjective("timer").getScore(player)}
                catch {var score2 = 0;}
                if(score2 >= 1) {
                    player.runCommand(`scoreboard players random @s identifier2 -2000000000 2000000000`);
                }
                player.runCommand(`scoreboard players reset @s timer`);

                var doesDurabilityDamage = true;
                var bulletScore = 1;
                fireAlt(player, item, itemSlot, itemSelected, itemDurability, currentDurability, doesDurabilityDamage, bulletScore, playerRotation, viewVector.x, viewVector.y, viewVector.z, x, y, z);
                doesDurabilityDamage = false;
        
                if(score == throwables[item].starting_score) {
                    fireAttributes(item, player, recoilScore, lowR, midR, lowC, midC, highC, loudRange, quietRange, loudness, sound);
        
                    //var recoil;                                                                                             //testing purposes
                    //if(recoilScore >= throwables[item].high_recoil) {                                                       //testing purposes
                    //    recoil = "§cHGH";                                                                                   //testing purposes
                    //}                                                                                                       //testing purposes
                    //else if(recoilScore > throwables[item].low_recoil && recoilScore <= throwables[item].mid_recoil) {      //testing purposes
                    //    recoil = "§eMED";                                                                                   //testing purposes
                    //}                                                                                                       //testing purposes
                    //else {                                                                                                  //testing purposes
                    //    recoil = "§aLOW";                                                                                   //testing purposes
                    //}                                                                                                       //testing purposes
                    //player.runCommandAsync(`tellraw @s {"rawtext":[{"text":"§7recoil: ${recoilScore} (${recoil}§7)"}]}`);   //testing purposes
                }
            }
            else {
                var identifier2 = world.scoreboard.getObjective("identifier2").getScore(player);
                try { player.runCommand(`tag @e[family=javelin_lock,scores={identifier2=${identifier2}}] add kill`); } catch {}

                player.runCommand(`scoreboard players random @s identifier2 -2000000000 2000000000`);
                const identifier = world.scoreboard.getObjective("identifier").getScore(player);
                var identifier2 = world.scoreboard.getObjective("identifier2").getScore(player);

                var projectile = player.dimension.spawnEntity(throwables[item].projectile3, { 'x': x, 'y': y, 'z': z });
                projectile.runCommand(`scoreboard players set @s identifier ${identifier}`);
                projectile.runCommand(`scoreboard players set @s identifier2 ${identifier2}`);
            
                
                projectile.setRotation({ x: -playerRotation.x, y: -playerRotation.y});
                projectile.applyImpulse(new Vector((viewVector.x) * throwables[item].projectileVelo, (viewVector.y) * throwables[item].projectileVelo, (viewVector.z) * throwables[item].projectileVelo));
                //lastShot[`${player.id}${item}`] = system.currentTick;
            }
            world.scoreboard.getObjective(scoreboardName).setScore(player, score - 1);
        }




        else if (throwables[item].projectile == "yes:mgl105_grenade" && score == throwables[item].starting_score) {
            //console.warn(`shot`);
            //player.runCommandAsync(`say he`);   //testing purposes
            const throwLoop = system.runInterval(() => {
                var score = world.scoreboard.getObjective(scoreboardName).getScore(player);
                const recoilScore = world.scoreboard.getObjective("recoil").getScore(player);
                const holdDetect = world.scoreboard.getObjective("hold_detector").getScore(player);

                //const recoilScore = player.scoreboard.getScore(world.scoreboard.getObjective("recoil"));                    //testing purposes
                //var recoil;                                                                                                 //testing purposes
                //if(recoilScore >= throwables[item].high_recoil) {                                                           //testing purposes
                //    recoil = "§cHGH";                                                                                       //testing purposes
                //}                                                                                                           //testing purposes
                //else if(recoilScore > throwables[item].low_recoil && recoilScore <= throwables[item].mid_recoil) {          //testing purposes
                //    recoil = "§eMED";                                                                                       //testing purposes
                //}                                                                                                           //testing purposes
                //else {                                                                                                      //testing purposes
                //    recoil = "§aLOW";                                                                                       //testing purposes
                //}                                                                                                           //testing purposes
                if(score == throwables[item].starting_score) {
                    fire(player, item, itemSlot, itemSelected, itemDurability, currentDurability, true);
                    fireAttributes(item, player, recoilScore, lowR, midR, lowC, midC, highC, loudRange, quietRange, loudness, sound);
                    //player.runCommandAsync(`say shoot`);
                    
                    //player.runCommandAsync(`say ${throwables[item].projectile}`);   //testing purposes
                }
                //if((chargeUp == 0 || chargeUp == 2) && holdDetect%2 == 0) {
                //    try {
                //        essential         = player.getComponent('minecraft:inventory').container;
                //        itemSlot          = essential.getSlot(player.selectedSlot);
                //        itemSelected      = itemSlot.getItem();
                //        itemDurability    = itemSelected.getComponent("minecraft:durability");
                //        currentDurability   = itemDurability.maxDurability - itemDurability.damage;
                //        itemSelected.getComponent("minecraft:durability").damage = itemDurability.maxDurability - (currentDurability - 1);
                //        itemSlot.setItem(itemSelected);
                //        chargeUp++;
                //        player.runCommandAsync(`say delete chargeUp ${score}`);
                //        //player.runCommandAsync(`say minus`);
                //    }
                //    catch {}
                //}
                //else if((chargeUp == 1 || chargeUp == 3) && holdDetect%2 == 0) {
                //    try {
                //        essential         = player.getComponent('minecraft:inventory').container;
                //        itemSlot          = essential.getSlot(player.selectedSlot);
                //        itemSelected      = itemSlot.getItem();
                //        itemDurability    = itemSelected.getComponent("minecraft:durability");
                //        currentDurability   = itemDurability.maxDurability - itemDurability.damage;
                //        itemSelected.getComponent("minecraft:durability").damage = itemDurability.maxDurability - (currentDurability + 1);
                //        itemSlot.setItem(itemSelected);
                //        chargeUp++;
                //        player.runCommandAsync(`say add chargeUp ${score}`);
                //        //player.runCommandAsync(`say add`);
                //    }
                //    catch {}
                //} 
                score = world.scoreboard.getObjective(scoreboardName).getScore(player);
                if(score > 0) {
                    world.scoreboard.getObjective(scoreboardName).setScore(player, score - 1);
                }
                delete playersThrowing[eventData.source.id];
                system.clearRun(throwLoop);
                chargeUp = 0;
                return;
            }, 0);
            playersThrowing[player.id] = throwLoop;
            //const recoilScore = player.scoreboard.getScore(world.scoreboard.getObjective("recoil"));
            //const holdDetect = player.scoreboard.getScore(world.scoreboard.getObjective("hold_detector"));

            //if((holdDetect >= 5)) {
            //    fire(player, item, itemSlot, itemSelected, itemDurability, currentDurability, true);
            //    fireAttributes(item, player, recoilScore, lowR, midR, lowC, midC, highC, loudRange, quietRange, loudness, sound);
            //    player.runCommandAsync(`scoreboard players add @s test 1`);   //testing purposes
    //
            //    var recoil;                                                                                             //testing purposes
            //    if(recoilScore >= throwables[item].high_recoil) {                                                       //testing purposes
            //        recoil = "§cHGH";                                                                                   //testing purposes
            //    }                                                                                                       //testing purposes
            //    else if(recoilScore > throwables[item].low_recoil && recoilScore <= throwables[item].mid_recoil) {      //testing purposes
            //        recoil = "§eMED";                                                                                   //testing purposes
            //    }                                                                                                       //testing purposes
            //    else {                                                                                                  //testing purposes
            //        recoil = "§aLOW";                                                                                   //testing purposes
            //    }                                                                                                       //testing purposes
            //    player.runCommandAsync(`tellraw @s {"rawtext":[{"text":"§7recoil: ${recoilScore} (${recoil}§7)"}]}`);   //testing purposes
            //}
        }




        else if(throwables[item].projectile == "yes:ump45_bullet" && score == throwables[item].starting_score) {
            const throwLoop = system.runInterval(() => {
                var score = world.scoreboard.getObjective(scoreboardName).getScore(player);
                if(score > 0) {
                    world.scoreboard.getObjective(scoreboardName).setScore(player, score - 1);
                }
                const holdDetect = world.scoreboard.getObjective("hold_detector").getScore(player);

                const recoilScore = world.scoreboard.getObjective("recoil").getScore(player);                  //testing purposes
                var recoil;                                                                                                 //testing purposes
                if(recoilScore >= throwables[item].high_recoil) {                                                           //testing purposes
                    recoil = "§cHGH";                                                                                       //testing purposes
                }                                                                                                           //testing purposes
                else if(recoilScore > throwables[item].low_recoil && recoilScore <= throwables[item].mid_recoil) {          //testing purposes
                    recoil = "§eMED";                                                                                       //testing purposes
                }                                                                                                           //testing purposes
                else {                                                                                                      //testing purposes
                    recoil = "§aLOW";                                                                                       //testing purposes
                }                                                                                                           //testing purposes
                if(holdDetect%3 == 1) {
                    if(score == 3) {
                        fire(player, item, itemSlot, itemSelected, itemDurability, currentDurability, true);
                        //player.runCommandAsync(`tellraw @s {"rawtext":[{"text":"§7recoil: ${recoilScore} (${recoil}§7)"}]}`);     //testing purposes
                        fireAttributes(item, player, recoilScore, lowR, midR, lowC, midC, highC, loudRange, quietRange, loudness, sound);
                        //chargeUp++;
                    player.runCommandAsync(`scoreboard players add @s test 1`);   //testing purposes
                    //player.runCommandAsync(`say shot 1`);   //testing purposes
                    }
                }
                else if(holdDetect%3 == 2) {
                    if(score == 4 || score == 1) {
                        essential         = player.getComponent('minecraft:inventory').container;
                        itemSlot          = essential.getSlot(player.selectedSlot);
                        itemSelected      = itemSlot.getItem();
                        itemDurability    = itemSelected.getComponent("minecraft:durability");
                        currentDurability   = itemDurability.maxDurability - itemDurability.damage;
                        fire(player, item, itemSlot, itemSelected, itemDurability, currentDurability, true);
                        //layer.runCommandAsync(`tellraw @s {"rawtext":[{"text":"§7recoil: ${recoilScore} (${recoil}§7)"}]}`);     //testing purposes
                        fireAttributes(item, player, recoilScore, lowR, midR, lowC, midC, highC, loudRange, quietRange, loudness, sound);
                        //chargeUp++;
                    player.runCommandAsync(`scoreboard players add @s test 1`);   //testing purposes
                    //player.runCommandAsync(`say shot 2`);   //testing purposes
                    }
                }
                else if(holdDetect%3 == 0) {
                    if(score == 2) {
                        fire(player, item, itemSlot, itemSelected, itemDurability, currentDurability, true);
                        //player.runCommandAsync(`tellraw @s {"rawtext":[{"text":"§7recoil: ${recoilScore} (${recoil}§7)"}]}`);     //testing purposes
                        fireAttributes(item, player, recoilScore, lowR, midR, lowC, midC, highC, loudRange, quietRange, loudness, sound);
                        //chargeUp++;
                    player.runCommandAsync(`scoreboard players add @s test 1`);   //testing purposes
                    //player.runCommandAsync(`say shot 1`);   //testing purposes
                    }
                }
                score = world.scoreboard.getObjective(scoreboardName).getScore(player);
                if ((holdDetect%3 == 2) && score <= 0 || chargeUp == 2) {
                    delete playersThrowing[eventData.source.id];
                    system.clearRun(throwLoop);
                    chargeUp = 0;
                    return;
                }
                else if (score <= 0 || chargeUp == 1) {
                    delete playersThrowing[eventData.source.id];
                    system.clearRun(throwLoop);
                    chargeUp = 0;
                    return;
                }
            }, 0);
            playersThrowing[player.id] = throwLoop;
        }




        else if (throwables[item].fire_mode == "semi" && score == throwables[item].starting_score) {
            
            let viewVector = player.getViewDirection();
            const playerRotation = player.getRotation();
            if (playerRotation.x > 30) {
                viewVector.x *= 2.1;
                viewVector.y *= 2.1;
                viewVector.z *= 2.1;
            }
            const { x, y, z } = Vector.add(player.getHeadLocation(), viewVector);
            //player.runCommandAsync(`say ${viewVector.x}`);
            var secondBullet = throwables[item].starting_score;
            var bulletsEach = 1;
            if(throwables[item].amount_of_bullets == 1) {
                secondBullet = throwables[item].starting_score;
                bulletsEach = 1;
            }
            else if(throwables[item].amount_of_bullets == 2) {
                secondBullet = throwables[item].starting_score - 2;
                bulletsEach = 1;
            }
            else if(throwables[item].amount_of_bullets == 8) {
                secondBullet = throwables[item].starting_score - 2;
                bulletsEach = 4;
            }
            //for testing //
            var essential         = player.getComponent('minecraft:inventory').container;
            itemSlot          = essential.getSlot(player.selectedSlot);
            itemSelected      = itemSlot.getItem();
            itemDurability    = itemSelected.getComponent("minecraft:durability");
            var oldDurability   = itemDurability.maxDurability - itemDurability.damage;
            //for testing //

            const throwLoop = system.runInterval(() => {
                var item = eventData.itemStack.typeId;
                if(item.substring(0,16) == "yes:remington870") {
                    item = "yes:remington870";
                }
                else if(item.substring(0,12) == "yes:ithaca37") {
                    item = "yes:ithaca37";
                }
                var score = world.scoreboard.getObjective(scoreboardName).getScore(player);
                const recoilScore = world.scoreboard.getObjective("recoil").getScore(player);

                
                var essential         = player.getComponent('minecraft:inventory').container;
                itemSlot          = essential.getSlot(player.selectedSlot);
                itemSelected      = itemSlot.getItem();
                itemDurability    = itemSelected.getComponent("minecraft:durability");
                currentDurability   = itemDurability.maxDurability - itemDurability.damage;
                

                if(score == throwables[item].starting_score || score == secondBullet) {
                    if(score == throwables[item].starting_score) {
                        var doesDurabilityDamage = true;
                        var bulletScore = 1;
                    }
                    else {
                        var doesDurabilityDamage = false;
                        var bulletScore = 2;
                    }
                    for(var i=0; i<bulletsEach; i++) {
                        fireAlt(player, item, itemSlot, itemSelected, itemDurability, currentDurability, doesDurabilityDamage, bulletScore, playerRotation, viewVector.x, viewVector.y, viewVector.z, x, y, z, oldDurability);
                        doesDurabilityDamage = false;
                        //player.runCommandAsync(`say ${bulletScore}`);
                    }
                }
        
                if(score == throwables[item].starting_score) {
                    //console.warn("fire attribute");
                    fireAttributes(item, player, recoilScore, lowR, midR, lowC, midC, highC, loudRange, quietRange, loudness, sound);
        
                    //var recoil;                                                                                             //testing purposes
                    //if(recoilScore >= throwables[item].high_recoil) {                                                       //testing purposes
                    //    recoil = "§cHGH";                                                                                   //testing purposes
                    //}                                                                                                       //testing purposes
                    //else if(recoilScore > throwables[item].low_recoil && recoilScore <= throwables[item].mid_recoil) {      //testing purposes
                    //    recoil = "§eMED";                                                                                   //testing purposes
                    //}                                                                                                       //testing purposes
                    //else {                                                                                                  //testing purposes
                    //    recoil = "§aLOW";                                                                                   //testing purposes
                    //}                                                                                                       //testing purposes
                    //player.runCommandAsync(`tellraw @s {"rawtext":[{"text":"§7recoil: ${recoilScore} (${recoil}§7)"}]}`);   //testing purposes
                }


                // //for testing //
                // var essential         = player.getComponent('minecraft:inventory').container;
                // itemSlot          = essential.getSlot(player.selectedSlot);
                // itemSelected      = itemSlot.getItem();
                // itemDurability    = itemSelected.getComponent("minecraft:durability");
                // currentDurability   = itemDurability.maxDurability - itemDurability.damage;
                // //for testing //
                //console.warn(`2 dur `+currentDurability);
                if(score > 0) {
                    world.scoreboard.getObjective(scoreboardName).setScore(player, score - 1);
                }

                score = world.scoreboard.getObjective(scoreboardName).getScore(player);
                if (score <= 0) {
                    delete playersThrowing[eventData.source.id];
                    system.clearRun(throwLoop);
                    chargeUp = 0;
                    ////for testing //
                    //essential         = player.getComponent('minecraft:inventory').container;
                    //itemSlot          = essential.getSlot(player.selectedSlot);
                    //itemSelected      = itemSlot.getItem();
                    //itemDurability    = itemSelected.getComponent("minecraft:durability");
                    //currentDurability   = itemDurability.maxDurability - itemDurability.damage;
                    ////for testing //
                    //console.warn(`3 dur `+currentDurability);
                    return;
                }
            }, 0);
            playersThrowing[player.id] = throwLoop;
        }



        
        else if (throwables[item].fire_mode == "auto" && score == throwables[item].starting_score) {
            
            var holdDetect = world.scoreboard.getObjective("hold_detector").getScore(player);
            const throwLoop = system.runInterval(() => {
                var score = world.scoreboard.getObjective(scoreboardName).getScore(player);
                if(score > 0) {
                    world.scoreboard.getObjective(scoreboardName).setScore(player, score - 1);
                }
                holdDetect = world.scoreboard.getObjective("hold_detector").getScore(player);

                //const recoilScore = player.scoreboard.getScore(world.scoreboard.getObjective("recoil"));                    //testing purposes
                //var recoil;                                                                                                 //testing purposes
                //if(recoilScore >= throwables[item].high_recoil) {                                                           //testing purposes
                //    recoil = "§cHGH";                                                                                       //testing purposes
                //}                                                                                                           //testing purposes
                //else if(recoilScore > throwables[item].low_recoil && recoilScore <= throwables[item].mid_recoil) {          //testing purposes
                //    recoil = "§eMED";                                                                                       //testing purposes
                //}                                                                                                           //testing purposes
                //else {                                                                                                      //testing purposes
                //    recoil = "§aLOW";                                                                                       //testing purposes
                //}                                                                                                           //testing purposes
                
                if(holdDetect == 1 && score == (throwables[item].starting_score - 1)) {
                    fire(player, item, itemSlot, itemSelected, itemDurability, currentDurability, true);
                    fireAttributes(item, player, recoilScore, lowR, midR, lowC, midC, highC, loudRange, quietRange, loudness, sound);
                    chargeUp++;
                }

                if(throwables[item].second_bullet_scoreboard_contained == true && (score >= scoreMin && score <= scoreMax) && holdDetect > 1) {
                    fire(player, item, itemSlot, itemSelected, itemDurability, currentDurability, true);
                    fireAttributes(item, player, recoilScore, lowR, midR, lowC, midC, highC, loudRange, quietRange, loudness, sound);
                    chargeUp++;
                //    player.runCommandAsync(`tellraw @s {"rawtext":[{"text":"§7recoil: ${recoilScore} (${recoil}§7)"}]}`);   //testing purposes
                }
                else if(throwables[item].second_bullet_scoreboard_contained == false && (score == scoreMin || score == scoreMax) && holdDetect > 1) {
                    fire(player, item, itemSlot, itemSelected, itemDurability, currentDurability, true);
                    fireAttributes(item, player, recoilScore, lowR, midR, lowC, midC, highC, loudRange, quietRange, loudness, sound);
                    chargeUp++;
                }
                score = world.scoreboard.getObjective(scoreboardName).getScore(player);
                if (score <= 0 || chargeUp == throwables[item].amount_of_bullets) {
                    delete playersThrowing[eventData.source.id];
                    system.clearRun(throwLoop);
                    chargeUp = 0;
                    return;
                }
            // player.runCommandAsync(`SAY ${score}`);   //testing purposes
            }, 0);
            playersThrowing[player.id] = throwLoop;
            const recoilScore = world.scoreboard.getObjective("recoil").getScore(player);
            //player.runCommandAsync(`SAY ${score}`);   //testing purposes
            if(holdDetect > 1) {
                fire(player, item, itemSlot, itemSelected, itemDurability, currentDurability, true);
                fireAttributes(item, player, recoilScore, lowR, midR, lowC, midC, highC, loudRange, quietRange, loudness, sound);
                chargeUp++;
            }

            //var recoil;                                                                                             //testing purposes
            //if(recoilScore >= throwables[item].high_recoil) {                                                       //testing purposes
            //    recoil = "§cHGH";                                                                                   //testing purposes
            //}                                                                                                       //testing purposes
            //else if(recoilScore > throwables[item].low_recoil && recoilScore <= throwables[item].mid_recoil) {      //testing purposes
            //    recoil = "§eMED";                                                                                   //testing purposes
            //}                                                                                                       //testing purposes
            //else {                                                                                                  //testing purposes
            //    recoil = "§aLOW";                                                                                   //testing purposes
            //}                                                                                                       //testing purposes
            //player.runCommandAsync(`tellraw @s {"rawtext":[{"text":"§7recoil: ${recoilScore} (${recoil}§7)"}]}`);   //testing purposes
        }



        
        else if (throwables[item].fire_mode == "burst" && score == throwables[item].starting_score) {
            let viewVector = player.getViewDirection();
            const playerRotation = player.getRotation();
            if (playerRotation.x > 30) {
                viewVector.x *= 2.1;
                viewVector.y *= 2.1;
                viewVector.z *= 2.1;
            }
            const { x, y, z } = Vector.add(player.getHeadLocation(), viewVector);

            const throwLoop = system.runInterval(() => {
                var item = eventData.itemStack.typeId;

                var score = world.scoreboard.getObjective(scoreboardName).getScore(player);
                const recoilScore = world.scoreboard.getObjective("recoil").getScore(player);

                itemDurability    = itemSelected.getComponent("minecraft:durability");
                currentDurability   = itemDurability.maxDurability - itemDurability.damage;

                if(score > (throwables[item].starting_score - throwables[item].burst_bullet_amount)) {
                    fireAlt(player, item, itemSlot, itemSelected, itemDurability, currentDurability, true, 1, playerRotation, viewVector.x, viewVector.y, viewVector.z, x, y, z);
                    fireAttributes(item, player, recoilScore, lowR, midR, lowC, midC, highC, loudRange, quietRange, loudness, sound);

                    //var recoil;                                                                                             //testing purposes
                    //if(recoilScore >= throwables[item].high_recoil) {                                                       //testing purposes
                    //    recoil = "§cHGH";                                                                                   //testing purposes
                    //}                                                                                                       //testing purposes
                    //else if(recoilScore > throwables[item].low_recoil && recoilScore <= throwables[item].mid_recoil) {      //testing purposes
                    //    recoil = "§eMED";                                                                                   //testing purposes
                    //}                                                                                                       //testing purposes
                    //else {                                                                                                  //testing purposes
                    //    recoil = "§aLOW";                                                                                   //testing purposes
                    //}                                                                                                       //testing purposes
                    //player.runCommandAsync(`tellraw @s {"rawtext":[{"text":"§7recoil: ${recoilScore} (${recoil}§7)"}]}`);   //testing purposes
                }
                if(score > 0) {
                    world.scoreboard.getObjective(scoreboardName).setScore(player, score - 1);
                }

                score = world.scoreboard.getObjective(scoreboardName).getScore(player);
                if (score <= 0) {
                    delete playersThrowing[eventData.source.id];
                    system.clearRun(throwLoop);
                    chargeUp = 0;
                    return;
                }
            }, 0);
            playersThrowing[player.id] = throwLoop;
            
        }
    }
});






async function fireAttributes(item, player, recoilScore, lowR, midR, lowC, midC, highC, loudRange, quietRange, loudness, sound) {
    if(item != "yes:javelin") {
        if(world.scoreboard.getObjective("scoped").getScore(player) == 1) { var recoilPercentage = throwables[item].scope.recoil_percentage; }
        else {  var recoilPercentage = 1; }
        
        if(recoilScore < lowR) {
            player.runCommandAsync(`camerashake add @s ${lowC*recoilPercentage} 0.14 rotational`);
        }
        else if(recoilScore > lowR && recoilScore < midR) {
            player.runCommandAsync(`camerashake add @s ${midC*recoilPercentage} 0.14 rotational`);
        }
        else {
            player.runCommandAsync(`camerashake add @s ${highC*recoilPercentage} 0.14 rotational`);
        }
        if(item == "yes:rpg7") {
            player.runCommandAsync(`camerashake add @s 0.006 3 rotational`);
            player.runCommandAsync(`camerashake add @s 0.008 8 rotational`);
        }
       // player.runCommandAsync(`particle yes:muzzle_blast ^-0.3^1.5^1`);
        //player.runCommandAsync(`particle yes:muzzle_flash ^-0.3^1.5^1`);
        player.runCommandAsync(`execute as @s at @s if block ~~~ air run setblock ~~~ yes:muzzle_flash_light`);
        player.runCommandAsync(`execute as @s at @s if block ~~3~ air run setblock ~~3~ yes:muzzle_flash_light`);
    }
    var soundRandom = randomNum(0.87,1.1);
    player.runCommandAsync(`playsound ${sound} @a[rm=${loudRange},r=${quietRange}] ~~1~ 1 ${soundRandom} ${loudness/200}`);
    player.runCommandAsync(`playsound ${sound} @a[rm=1,r=${loudRange}] ~~1~ 1 ${soundRandom} ${loudness/100}`);
    player.runCommandAsync(`playsound ${sound} @s ~~1~ 1 ${soundRandom} 1`);
    //player.runCommandAsync(`playsound ${sound} @a[r=16] ~~1~ 1 ${soundRandom} 1`);
    //player.runCommandAsync(`execute as @a[r=16,rm=1] at @s run playsound ${sound} @s ~~1~ 1 ${soundRandom} ${loudness/100}`); 
    player.runCommandAsync(`playanimation @s animation.gun_recoil_${item.substring(4,item.length)}`);
    //here for now, will change depending on weapon
    //console.warn(`animation.gun_recoil_`+item.substring(4,item.length));
    player.runCommandAsync(`event entity @e[type=yes:player_entity,c=1,r=3.7] yes:shooting`);
    if(item == "yes:desert_eagle" || item == "yes:glock18") { player.runCommandAsync(`event entity @e[type=yes:player_entity,c=1,r=3.7] yes:desert_eagle_slide_event`); }
    else if(item == "yes:mk13") { player.runCommandAsync(`event entity @e[type=yes:player_entity,c=1,r=3.7] yes:mk13_slide_event`); }
    else if(item == "yes:remington870") { player.runCommandAsync(`event entity @e[type=yes:player_entity,c=1,r=3.7] yes:remington870_slide_event`); }
}//




async function fire(player, item, itemSlot, itemSelected, itemDurability, currentDurability, doesDurabilityDamage) {
	const ammoObj = throwables[item].ammo;
    var holdDetect = world.scoreboard.getObjective("hold_detector").getScore(player);

        var identifier = world.scoreboard.getObjective("identifier").getScore(player);

        //console.warn(`first `+currentDurability);
        //console.warn(`lowest `+throwables[item].lowest_durability);
        //if (currentDurability == throwables[item].lowest_durability) {
        //    itemSelected.getComponent("minecraft:durability").damage = itemDurability.maxDurability;// - (currentDurability - throwables[item].lowest_durability);
        //    itemSlot.setItem(itemSelected);
        //}
        //currentDurability = itemDurability.maxDurability - itemDurability.damage;
        //console.warn(currentDurability);
        currentDurability = itemDurability.maxDurability - itemDurability.damage;
        if (currentDurability <= throwables[item].lowest_durability) {
            player.runCommandAsync(`replaceitem entity @s slot.weapon.mainhand 0 ${ammoObj.scoreboard.emptyItem} 1 1`);
            player.runCommandAsync(`tag @s add last_bullet`);
        }
        if (currentDurability > throwables[item].lowest_durability) {
            itemSelected.getComponent("minecraft:durability").damage = itemDurability.damage + 1;
            itemSlot.setItem(itemSelected);
        }
        //if (currentDurability > throwables[item].lowest_durability && doesDurabilityDamage && holdDetect == 2) {
        //    itemSelected.getComponent("minecraft:durability").damage = itemDurability.damage - 1;
        //    itemSlot.setItem(itemSelected);
        //    //console.warn(`dur `+currentDurability);
        //}

    
    player.runCommandAsync(`scoreboard players add @s test 1`);
	let viewVector = player.getViewDirection();
	const playerRotation = player.getRotation();
	if (playerRotation.x > 30) {
		viewVector.x *= 2.1;
		viewVector.y *= 2.1;
		viewVector.z *= 2.1;
	}
	const { x, y, z } = Vector.add(player.getHeadLocation(), viewVector);
    if(item == "yes:mgl105") {
        player.dimension.spawnEntity("yes:mgl105_grenade_dummy", { 'x': x, 'y': y, 'z': z });
    }
	const projectile = player.dimension.spawnEntity(throwables[item].projectile, { 'x': x, 'y': y, 'z': z });
    projectile.runCommand(`scoreboard players operation @s identifier = @p identifier`);
	projectile.setRotation({ x: -playerRotation.x, y: -playerRotation.y});
	projectile.applyImpulse(new Vector(viewVector.x * throwables[item].projectileVelo, viewVector.y * throwables[item].projectileVelo, viewVector.z * throwables[item].projectileVelo));
	lastShot[`${player.id}${item}`] = system.currentTick;
}





async function fireAlt(player, item, itemSlot, itemSelected, itemDurability, currentDurability, doesDurabilityDamage, bulletScore, playerRotation, lookX, lookY, lookZ, x, y, z, oldDurability) {
    player.runCommandAsync(`scoreboard players add @s test 1`);
	const ammoObj = throwables[item].ammo;
    const identifier = world.scoreboard.getObjective("identifier").getScore(player);
    const identifier2 = world.scoreboard.getObjective("identifier2").getScore(player);

    var essential         = player.getComponent('minecraft:inventory').container;
    itemSlot          = essential.getSlot(player.selectedSlot);
    itemSelected      = itemSlot.getItem();
    itemDurability    = itemSelected.getComponent("minecraft:durability");
    currentDurability   = itemDurability.maxDurability - itemDurability.damage;

    if (currentDurability <= (throwables[item].lowest_durability) && doesDurabilityDamage == true && throwables[item].does_durability_damage != false) {
        player.runCommandAsync(`replaceitem entity @s slot.weapon.mainhand 0 ${ammoObj.scoreboard.emptyItem} 1 1`);
        player.runCommandAsync(`tag @s add last_bullet`);
    }

    //console.warn(item);

    if ((currentDurability > (throwables[item].lowest_durability) && doesDurabilityDamage == true && throwables[item].does_durability_damage != false) || (oldDurability == currentDurability && throwables[item].does_durability_damage != false) ) {
        itemSelected.getComponent("minecraft:durability").damage = itemDurability.damage + 1;
        currentDurability = itemDurability.maxDurability - itemDurability.damage;
        itemSlot.setItem(itemSelected);
    }
    ////for testing //
    //var essential         = player.getComponent('minecraft:inventory').container;
    //itemSlot          = essential.getSlot(player.selectedSlot);
    //itemSelected      = itemSlot.getItem();
    //itemDurability    = itemSelected.getComponent("minecraft:durability");
    //currentDurability   = itemDurability.maxDurability - itemDurability.damage;
    ////for testing //
    //console.warn(`1 dur `+currentDurability);


    if(bulletScore == 2 && throwables[item].projectile2 == "") {
        return;
    }
    else if(bulletScore == 2 && throwables[item].projectile2) {
	    var projectile = player.dimension.spawnEntity(throwables[item].projectile2, { 'x': x, 'y': y, 'z': z });
        //player.runCommandAsync(`say ${throwables[item].projectile2}`);
    }
    else if(item != "yes:javelin") {
	    var projectile = player.dimension.spawnEntity(throwables[item].projectile, { 'x': x, 'y': y, 'z': z });
        //player.runCommandAsync(`say ${throwables[item].projectile}`);
    }
    else {
        player.runCommand(`tag @e[type=yes:javelin_target_lock_projectile,scores={identifier2=${identifier2}}] add fired`);
        player.runCommand(`summon yes:javelin_missile ^-0.4^1.5^2 facing ^^^300`);
        player.runCommand(`scoreboard players set @e[type=yes:javelin_missile,c=1,r=3] identifier2 ${identifier2}`);
        var projectile = player.dimension.getEntities({type:"yes:javelin_missile", scoreOptions:[{objective: "identifier2", maxScore: identifier2, minScore: identifier2}]})[0];
        projectile.runCommand(`scoreboard players set @s identifier ${identifier}`);
        
        player.runCommand(`summon yes:javelin_look ^-0.4^1.8^`);
        player.runCommand(`scoreboard players set @e[type=yes:javelin_look,c=1,r=3] identifier2 ${identifier2}`);
        var lookEntity = player.dimension.getEntities({type:"yes:javelin_look", scoreOptions:[{objective: "identifier2", maxScore: identifier2, minScore: identifier2}]})[0];
        lookEntity.runCommand(`scoreboard players set @s identifier ${identifier}`);
        player.runCommand(`tp @e[type=yes:javelin_look,scores={identifier2=${identifier2}}] ^-0.4^4^30`);
    }
    projectile.runCommand(`scoreboard players operation @s identifier = @p identifier`);

    if(playerRotation.x < 0 && ammoObj.scoreboard.name == "rpg7") {
        projectile.runCommandAsync(`summon yes:rpg_rocket_dummy ^^-2^`);
        projectile.runCommandAsync(`tag @e[type=yes:rpg_rocket_dummy,c=1,r=12] add below`);
        player.applyKnockback(-lookX, -lookZ, 2.5, 0.15);
    }
    else if (playerRotation.x > 0 && ammoObj.scoreboard.name == "rpg7") {
        projectile.runCommandAsync(`summon yes:rpg_rocket_dummy ^^2^`);
        projectile.runCommandAsync(`tag @e[type=yes:rpg_rocket_dummy,c=1,r=12] add above`);
        player.applyKnockback(-lookX, -lookZ, 2.5, 0.15);
    }
    if(ammoObj.scoreboard.name == "javelin" && projectile.runCommand(`testfor @e[family=javelin_lock,scores={identifier2=${identifier2}}]`).successCount == 0) {
        //console.warn(`heheheh ${identifier2}`);

        var projectile2 = player.dimension.spawnEntity(throwables[item].projectile2, { 'x': x, 'y': y, 'z': z });
        projectile2.setRotation({ x: -playerRotation.x, y: -playerRotation.y});
        projectile2.runCommand(`scoreboard players set @s identifier ${identifier}`);
        projectile2.runCommand(`scoreboard players set @s identifier2 ${identifier2}`);
        projectile2.applyImpulse(new Vector((lookX) * throwables[item].projectileVelo, (lookY) * throwables[item].projectileVelo, (lookZ) * throwables[item].projectileVelo));
    }
    
    if(projectile.typeId != "yes:javelin_missile") {
	    projectile.setRotation({ x: -playerRotation.x, y: -playerRotation.y});
        //console.warn(`rotated`);
    }
    //if(projectile.typeId == "yes:javelin_missile") {
        //projectile.setRotation({ x: playerRotation.x, y: playerRotation.y});
        //console.warn(`rotated`);
        //try { var otherEntity = entity.dimension.getEntities({closest: 1, families: ["javelin_lock"], score:{objective: "identifier2", maxScore: identifier2, minScore: identifier2}})[0]; }
        //catch { var otherEntity = projectile2 }
        //let entityLocation = entity.location;
        //let otherEntityLocation = otherEntity.location;
        //projectile.teleport({x:entityLocation.x, y:entityLocation.y, z:entityLocation.z}, {keepVelocity:true, facingLocation:{x:otherEntityLocation.x, y:otherEntityLocation.y, z:otherEntityLocation.z}});
    //}
    var spread = throwables[item].spread;
	projectile.applyImpulse(new Vector((lookX+randomNum(-spread, spread)) * throwables[item].projectileVelo, (lookY+randomNum(-spread, spread)) * throwables[item].projectileVelo, (lookZ+randomNum(-spread, spread)) * throwables[item].projectileVelo));
	lastShot[`${player.id}${item}`] = system.currentTick;
}



function randomNum(min, max) {
	return Math.random() * (max - min) + min; // You can remove the Math.floor if you don't want it to be an integer
}




world.afterEvents.projectileHitEntity.subscribe(async (eventData) => {
    const projectile = eventData.projectile;
    try { eventData.getEntityHit().entity; projectile.location; eventData.getEntityHit().entity.getComponent('health').currentValue; }
    catch { return; }
    var target = eventData.getEntityHit().entity;

    if(projectile.typeId == "yes:javelin_target_lock_projectile" && projectile.runCommand(`testfor @s[tag=hit]`).successCount == 0) {
        const identifier2 = world.scoreboard.getObjective("identifier2").getScore(projectile);
        target.runCommand(`scoreboard players set @s temp ${identifier2}`);
        projectile.runCommand(`tp @s @e[type=${target.typeId},scores={temp=${identifier2}},c=1]`);
        target.runCommand(`scoreboard players reset @s temp`);
        //console.warn(`e`);
        //target.runCommand(`scoreboard players set @s identifier3 ${identifier2}`);
        //target.runCommand(`summon yes:javelin_target_lock ~~~`);
        //target.runCommand(`scoreboard players operation @e[type=yes:javelin_target_lock,c=1] identifier2 = @s identifier3`);
    }
    if (projectile.typeId == "yes:mgl105_grenade") return;
    if(!bullets[projectile.typeId]) return;
    const testfor1 = target.runCommand(`testfor @s[m=c]`).successCount;
    if (testfor1 == 1) return;

    //console.warn(`first`)
    var health = target.getComponent('health').currentValue;
    //console.warn(`last`)
    var damage = bullets[projectile.typeId].damage;

    try   { var targetIdentifier = world.scoreboard.getObjective("identifier").getScore(target); } 
    catch { var targetIdentifier = "no score"; }

    const projectileIdentifier = world.scoreboard.getObjective("identifier").getScore(projectile);
    //console.warn(`${projectileIdentifier}`);
    const projectilePierce = bullets[projectile.typeId].pierce;
    if (targetIdentifier == "no score") {
        target.getComponent('health').setCurrentValue(health-damage*2);
        if(projectile.runCommand(`testfor @s[family=!no_dmg]`).successCount == 1) {
            //target.runCommand(`damage @s 0`);
            target.runCommand(`damage @s 0 override`);
            //target.runCommand(`damage @s 0 void entity @e[type=${projectile.typeId},c=1]`);
            //target.runCommand(`say ${projectile.typeId}`);
        }
        projectile.runCommand(`scoreboard players add @s bullet_hits 1`);
        projectile.runCommand(`kill @s[scores={bullet_hits=${projectilePierce}..}]`);
    }
    
    else {
    //target.runCommandAsync(`say PROJECTILE ${projectile}`);
        if (targetIdentifier != projectileIdentifier) {
            const deafness_score = bullets[projectile.typeId].damage * 40;
            target.getComponent('health').setCurrentValue(health-damage);
            target.runCommandAsync(`camerashake add @s 0.0008 14 positional`);
            target.runCommandAsync(`camerashake add @s 0.003 8 positional`);
            target.runCommandAsync(`scoreboard players add @s deafness ${deafness_score}`);
            target.runCommandAsync(`title @s times 0 10 180`);
            target.runCommandAsync(`title @s title `);
            target.runCommandAsync(`title @s reset`);
            //target.runCommandAsync(`playsound yes.deafen @s ~~1~ 1 1`);
            target.runCommand(`damage @s 0 override`);
            projectile.runCommand(`kill @s`);
        }
        //else {
        //    projectile.runCommandAsync(`scoreboard players set @s bullet_hits -1`);
        //}
    }
});



//world.beforeEvents.dataDrivenEntityTriggerEvent.subscribe(async (eventData) => {
//    console.warn(`event: ${eventData.id}`);
//    //console.warn(`entity: ${eventData.entity.typeId}`);
//    if(eventData.id == "yes:on_hit" && eventData.entity.typeId == "yes:mgl105_grenade") {
//        console.warn(`SUCCESS`);
//    }
//});




world.afterEvents.projectileHitBlock.subscribe(async (eventData) => {
    const projectile = eventData.projectile;

    try { eventData.getBlockHit().block; projectile.location; }
    catch { return; }
    if(projectile.typeId == "yes:mgl105_grenade") {
        const hitFace = eventData.getBlockHit().face;
        if(projectile.runCommand(`testfor @s[tag=!initial_bounce]`).successCount == 1) { var multiplier = 5; var multiplier2 = 5; }
        else { var multiplier = 1.5; var multiplier2 = 1.3; }
        //var rotation = projectile.getViewDirection();
        //console.warn(`${rotation.y}`);

        //R*Econsole.warn(hitFace);
        if(hitFace == "Up" || hitFace == "Down" ) {
            //console.warn(hitFace);
            var { x, y, z } = projectile.getVelocity();
            //projectile.runCommand(`say before ${x}, ${y}, ${z}`);
            //projectile.runCommand(`say y: ${-y*1.5}`);
            projectile.runCommand(`scoreboard objectives add grenade dummy`);
            projectile.runCommand(`scoreboard players set @s grenade 0`);
            projectile.runCommand(`execute as @s at @s if block ~~~ air run scoreboard players set @s grenade 1`);
            if(hitFace == "Up") {
                projectile.runCommand(`tp @s ~~${-y*1}~`);
                //projectile.runCommand(`say up`);
            }
            else if(hitFace == "Down") {
                projectile.runCommand(`tp @s ~~${-y*1}~`);
                //projectile.runCommand(`say down`);
            }

            projectile.clearVelocity();
            projectile.applyImpulse(new Vector(x/multiplier, -y/multiplier2, z/multiplier));
            //if(projectile.runCommand(`testforblock ~~~ air`).successCount == 0) {
            //    console.warn(`not air`);
            //}
            //var rotation = projectile.getViewDirection();
            var { x, y, z } = projectile.getVelocity();
            //projectile.runCommand(`say after ${x}, ${y}, ${z}`);
        }
        else if(hitFace == "East" || hitFace == "West" ) {

            var { x, y, z } = projectile.getVelocity();
            //projectile.runCommand(`say before ${x}, ${y}, ${z}`);
            projectile.runCommand(`scoreboard objectives add grenade dummy`);
            projectile.runCommand(`scoreboard players set @s grenade 0`);
            projectile.runCommand(`execute as @s at @s if block ~~~ air run scoreboard players set @s grenade 1`);
            if(hitFace == "East") {
                projectile.runCommand(`tp @s ~${-x}~~`);
                //projectile.runCommand(`say east`);
            }
            else if(hitFace == "West") {
                projectile.runCommand(`tp @s ~${-x}~~`);
                //projectile.runCommand(`say west`);
            }

            projectile.clearVelocity();
            projectile.applyImpulse(new Vector(-x/multiplier2, y/multiplier, z/multiplier));
            var { x, y, z } = projectile.getVelocity();
            //projectile.runCommand(`say after ${x}, ${y}, ${z}`);
        }
        else if(hitFace == "North" || hitFace == "South" ) {

            var { x, y, z } = projectile.getVelocity();
            //projectile.runCommand(`say before ${x}, ${y}, ${z}`);
            projectile.runCommand(`scoreboard objectives add grenade dummy`);
            projectile.runCommand(`scoreboard players set @s grenade 0`);
            projectile.runCommand(`execute as @s at @s if block ~~~ air run scoreboard players set @s grenade 1`);
            if(hitFace == "North") {
                projectile.runCommand(`tp @s ~~~${-z}`);
                //projectile.runCommand(`say north`);
            }
            else if(hitFace == "South") {
                projectile.runCommand(`tp @s ~~~${-z}`);
                //projectile.runCommand(`say south`);
            }

            projectile.clearVelocity();
            projectile.applyImpulse(new Vector(x/multiplier, y/multiplier, -z/multiplier2));
            var { x, y, z } = projectile.getVelocity();
            //projectile.runCommand(`say after ${x}, ${y}, ${z}`);
        }
        projectile.runCommand(`tag @s[tag=!initial_bounce] add initial_bounce`);
        //projectile.runCommand(`say on contatct`);
        if(projectile.runCommand(`testfor @s[tag=can_explode]`).successCount == 1) {
            //projectile.runCommand(`say hi`);
            //projectile.runCommand(`tag @s add explode`);
            projectile.runCommand(`scoreboard objectives add identifier2 dummy`);
            projectile.runCommand(`scoreboard players add @s identifier2 0`);
            projectile.runCommand(`scoreboard players random @s[scores={identifier2=0}] identifier2 -2000000000 2000000000`);
            var identifier = world.scoreboard.getObjective("identifier2").getScore(projectile);
            projectile.runCommand(`structure save grenade_bottom_${identifier} ~4~-1~4 ~-4~-4~-4 false memory`);
            projectile.runCommand(`structure save grenade_top_${identifier} ~4~1~4 ~-4~4~-4 false memory`);
            projectile.runCommand(`summon yes:mgl105_grenade_dummy2`);
            projectile.runCommand(`scoreboard players operation @e[type=yes:mgl105_grenade_dummy2,c=1,r=5] identifier2 = @s identifier2`);
            projectile.runCommand(`particle yes:explosion_flash ~~~`);
            projectile.runCommand(`event entity @e[type=yes:mgl105_grenade_dummy,c=1,r=10] yes:explode`);
            
            projectile.runCommand(`execute as @s[tag=dotiledrops_true] run gamerule dotiledrops false`);
            projectile.runCommand(`execute as @s[tag=dotiledrops_true] run tag @e[type=yes:mgl105_grenade_dummy2] add dotiledrops_true`);
            projectile.kill();
            return;

        } 
    }
    else if(projectile.runCommand(`execute if entity @e[type=yes:global_entity,scores={block_break=-1}] run testfor @s`).successCount == 1) {
        var projectileList = [ "yes:rpg_rocket", "yes:javelin_block_lock_projectile", "yes:javelin_target_lock_projectile", "yes:javelin_missile"];
        for(var i=0;i<projectileList.length;i++) {
            if(projectile.typeId == projectileList[i]) {
                return;
            }
        }
        //console.warn(`died`);
        projectile.remove();
        return;
    }
    if(!bullets[projectile.typeId]) return;

    const block = eventData.getBlockHit().block.typeId;
    const preTag = eventData.getBlockHit().block;
    const tags = eventData.getBlockHit().block.getTags();
    var {x, y, z} = eventData.getBlockHit().block.location;
    
    
    const throwLoop = system.runInterval(() => {
        try {
            var blockDamage = 0;
            blockDamage = projectile.runCommand(`testfor @e[family=damage1,r=1]`).successCount + 3*projectile.runCommand(`testfor @e[family=damage3,r=1]`).successCount + 5*projectile.runCommand(`testfor @e[family=damage5,r=1]`).successCount + 10*projectile.runCommand(`testfor @e[family=damage10,r=1]`).successCount;
            //projectile.runCommandAsync(`say block: ${block} tags: ${tags} projectiles: ${blockDamage}`);
            var blockList1 = ["glass", "stained_glass", "glass_pane", "stained_glass_pane", "tinted_glass", "leaves", "leaves2", "azalea_leaves", "azalea_leaves_flowered", "mangrove_leaves", "mangrove_roots"];
            var blockList3 = ["dirt", "farmland", "grass_path", "grass", "dirt_with_roots", "sand", "gravel", "netherrack", "acacia_door", "birch_door", "dark_oak_door", "jungle_door", "mangrove_door", "wooden_door", "spruce_door", "warped_door", "crimson_door", "acacia_trapdoor", "birch_trapdoor", "dark_oak_trapdoor", "jungle_trapdoor", "mangrove_trapdoor", "trapdoor", "spruce_trapdoor", "warped_trapdoor", "crimson_trapdoor", "acacia_fence", "birch_fence", "dark_oak_fence", "jungle_fence", "mangrove_fence", "oak_fence", "spruce_fence", "warped_fence", "crimson_fence", "acacia_fence_gate", "birch_fence_gate", "dark_oak_fence_gate", "jungle_fence_gate", "mangrove_fence_gate", "fence_gate", "spruce_fence_gate", "warped_fence_gate", "crimson_fence_gate"];
            var blockList5 = ["mud", "packed_mud", "muddy_mangrove_roots", "azalea_leaves", "crafting_table", "cartography_table", "fletching_table", "smithing_table", "bookshelf", "crimson_planks", "mangrove_planks", "warped_planks", "muddy_mangrove_roots", "mangrove_stairs", "crimson_stairs", "warped_stairs", "double_wooden_slab", "crimson_slab", "warped_slab", "crimson_double_slab", "warped_double_slab", "mangrove_log", "warped_stem", "crimson_stem", "stripped_mangrove_log", "stripped_warped_stem", "stripped_crimson_stem", "bamboo_planks", "cherry_planks", "mangrove_wood", "stripped_mangrove_wood", "warped_hyphae", "crimson_hyphae", "stripped_warped_hyphae", "stripped_crimson_hyphae", "sandstone", "red_sandstone", "sandstone_stairs", "smooth_sandstone_stairs", "red_sandstone_stairs", "smooth_red_sandstone_stairs", "stone_block_slab3", "stone_block_slab4"];
            var blockList10 = ["mud_bricks", "mud_brick_slab", "mud_brick_stairs", "mud_brick_wall", "end_stone", "end_bricks", "stone_block_slab3", "end_brick_stairs", "deepslate", "cobbled_deepslate", "cobbled_deepslate_wall", "cobbled_deepslate_stairs", "cobbled_deepslate_slab", "deepslate_tile_wall", "deepslate_tile_stairs", "deepslate_tiles", "polished_deepslate", "polished_deepslate_slab", "polished_deepslate_stairs", "polished_deepslate_wall", "deepslate_bricks", "deepslate_brick_slab", "deepslate_brick_stairs", "deepslate_brick_wall", "cracked_deepslate_bricks", "cracked_deepslate_tiles", "infested_deepslate", "blackstone", "blackstone_wall", "blackstone_stairs", "blackstone_slab", "polished_blackstone", "polished_blackstone_slab", "polished_blackstone_stairs", "polished_blackstone_wall", "polished_blackstone_bricks", "polished_blackstone_brick_slab", "polished_blackstone_brick_stairs", "polished_blackstone_brick_wall", "cracked_polished_blackstone_bricks", "smooth_stone", "normal_stone_stairs", "stone_stairs", "mossy_cobblestone_stairs", "stone_brick_stairs", "mossy_stone_brick_stairs", "granite_stairs", "polished_granite_stairs", "diorite_stairs", "polished_diorite_stairs", "andesite_stairs", "polished_andesite_stairs", "brick_stairs", "nether_brick_stairs", "quartz_stairs", "smooth_quartz_stairs", "prismarine_stairs", "dark_prismarine_stairs", "prismarine_bricks_stairs", "purpur_stairs", "quartz_block", "quartz_bricks", "purpur_block", "stone_block_slab2", "prismarine", "double_stone_block_slab", "double_stone_block_slab2", "double_stone_block_slab3", "double_stone_block_slab4", "smooth_stone", "bone_block", "nether_brick", "cracked_nether_bricks", "nether_brick_stairs", "nether_brick_fence", "chiseled_nether_bricks", "red_nether_brick", "red_nether_brick_stairs", "monster_egg", "infested_deepslate"];
            var blockList20 = ["black_concrete", "blue_concrete", "brown_concrete", "cyan_concrete", "gray_concrete", "green_concrete", "light_blue_concrete", "light_gray_concrete", "lime_concrete", "magenta_concrete", "orange_concrete", "pink_concrete", "purple_concrete", "red_concrete", "white_concrete", "yellow_concrete", "hardened_clay", "white_terracotta", "light_gray_terracotta", "gray_terracotta", "black_terracotta", "brown_terracotta", "red_terracotta", "orange_terracotta", "yellow_terracotta", "lime_terracotta", "green_terracotta", "cyan_terracotta", "light_blue_terracotta", "blue_terracotta", "purple_terracotta", "magenta_terracotta", "pink_terracotta"];
            //var filteredList = [];
            if(blockDamage >= 1) {
                for(var i=0; i<blockList1.length; i++) {
                    var string = "minecraft:"+blockList1[i];
                    if(block == string) {
                        destroyBlock(projectile, x, y, z, 1);
                        return;
                    }
                    //appendItem(filteredList, string);
                }
            }
            if(blockDamage >= 3) {
                for(var i=0; i<blockList3.length; i++) {
                    var string = "minecraft:"+blockList3[i];
                    if(block == string) {
                        destroyBlock(projectile, x, y, z, 3);
                        return;
                    }
                    //appendItem(filteredList, string);
                }
            }
            if(blockDamage >= 5) {
                if(preTag.hasTag("wood") || preTag.hasTag("log")) {
                    destroyBlock(projectile, x, y, z, 5);
                    return;
                }
                for(var i=0; i<blockList5.length; i++) {
                    var string = "minecraft:"+blockList5[i];
                    if(block == string) {
                        destroyBlock(projectile, x, y, z, 5);
                        return;
                    }
                    //appendItem(filteredList, string);
                }
            }
            if(blockDamage >= 10) {
                if(preTag.hasTag("stone") || preTag.hasTag("iron_pick_diggable")) {
                    if(block != "minecraft:raw_iron_block" && block != "minecraft:raw_gold_block") {
                        destroyBlock(projectile, x, y, z, 10);
                        return;
                    }
                }
                for(var i=0; i<blockList10.length; i++) {
                    var string = "minecraft:"+blockList10[i];
                    if(block == string) {
                        destroyBlock(projectile, x, y, z, 10);
                        return;
                    }
                }
            }
            if(blockDamage >= 20) {
                for(var i=0; i<blockList20.length; i++) {
                    var string = "minecraft:"+blockList20[i];
                    if(block == string) {
                        destroyBlock(projectile, x, y, z, 20);
                        return;
                    }
                }
            }
        } catch {}
        //if(amountOfBullets == 2 && (b == "minecraft:grass")) {
        //    projectile.runCommandAsync(`say 2`);
        //}
        //else if(amountOfBullets == 1 && (b == "minecraft:glass" || b == "minecraft:glass")) {
        //    projectile.runCommandAsync(`say 1`);
        //}
        system.clearRun(throwLoop);
        return;
    }, 0);
    
});

function destroyBlock(projectile, x, y, z, killAmount) {
    projectile.runCommand(`gamerule dotiledrops false`);
    projectile.runCommand(`setblock ${x} ${y} ${z} air destroy`);
    projectile.runCommand(`gamerule dotiledrops true`);
    projectile.runCommand(`kill @e[family=bullet,c=${killAmount},r=1]`);
}




world.getAllPlayers().forEach(playerSpawnFunction)

world.afterEvents.playerSpawn.subscribe(async (eventData) => {
    var player = eventData.player;
    var usingJavelin = false;
    var reloadFinished = 2;
    //console.warn(`thems ${player}`);

    //v ADD THIS BACK!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
    if(eventData.initialSpawn) {
        playerSpawnFunction(player, usingJavelin, reloadFinished);
    }
});


function playerSpawnFunction(player, usingJavelin, reloadFinished) {
    player.runCommand(`scoreboard players add @s deafness 0`);
    player.runCommand(`function settings`);
        
    const playerEntityLoop = system.runInterval(() => {
        try { player.name }
        catch { system.clearRun(playerEntityLoop); return; }
        
        //console.warn(player.runCommand(`testfor @s[tag=dead]`).successCount == 0);
        if(player.runCommand(`testfor @s[tag=dead]`).successCount == 0) {
            player.runCommandAsync(`scoreboard players random @s[scores={identifier=0}] identifier -2000000000 2000000000`);
            try { var identifier = world.scoreboard.getObjective("identifier").getScore(player); }
            catch { 
                player.runCommandAsync(`scoreboard objectives add identifier dummy`); 
                player.runCommandAsync(`scoreboard players random @s identifier -2000000000 2000000000`); 
                var identifier = world.scoreboard.getObjective("identifier").getScore(player);
            }
            var playerEntity = player.dimension.getEntities({type:"yes:player_entity", scoreOptions:[{objective: "identifier", maxScore: identifier, minScore: identifier}]})[0];
            if(playerEntity == undefined) {
                
                let viewVector = player.getViewDirection();
                const playerRotation = player.getRotation();
                if (playerRotation.x > 30) {
                    viewVector.x *= 2.1;
                    viewVector.y *= 2.1;
                    viewVector.z *= 2.1;
                }
                const { x, y, z } = Vector.add(player.getHeadLocation(), viewVector);
                var playerEntity = player.dimension.spawnEntity("yes:player_entity", { 'x': x, 'y': y, 'z': z });
                //R*Econsole.warn("summoned");
                playerEntity.runCommand(`scoreboard players set @s identifier ${identifier}`);
                
            }
        }
    }, 20);


    const otherLoop = system.runInterval(() => {
        try { player.name }
        catch { system.clearRun(otherLoop); return; }

        //player.runCommandAsync(`scoreboard players random @s[scores={identifier=0}] identifier -2000000000 2000000000`);
        //var identifier = world.scoreboard.getObjective("identifier").getScore(player);
        //var playerEntity = player.dimension.getEntities({type:"yes:player_entity", scoreOptions:[{objective: "identifier", maxScore: identifier, minScore: identifier}]})[0];
        //try { playerEntity.runCommandAsync(`tp @s @p[scores={identifier=${identifier}}]`); } catch {}
        
        try {
            world.scoreboard.getObjective("q_broken").setScore(player, 3);
        } 
        catch { player.runCommand(`scoreboard objectives add q_broken dummy`); }
    }, 0);

    var deafnessDelay = 0;
    const deafLoop = system.runInterval(() => {
        try { var deafness = world.scoreboard.getObjective("deafness").getScore(player); }
        catch { system.clearRun(deafLoop); return; }
        if(deafness > 0) {
            //player.runCommand(`say ${deafness/400}`);
            //player.runCommand(`playsound gun.ring_weewee @s ~~1~ ${deafness/400}`);
            //player.runCommand(`stopsound @s`);
            //player.runCommand(`playsound gun.ring_actual_weewee @s ~~1~ ${deafness/2000}`);
            if(deafnessDelay > 15) {
                player.runCommand(`stopsound @s`);
            }
            if(deafnessDelay < 16) {
                deafnessDelay++;
            }
        }
        else {
            deafnessDelay = 0;
        }
        //try {
        //    var reloadTime = world.scoreboard.getObjective("reload_timer").getScore(player);
        //    var essential     = player.getComponent('minecraft:inventory').container;
        //    var itemSlot      = essential.getSlot(player.selectedSlot);
        //    var itemSelected  = itemSlot.getItem().typeId;
//
        //    //if(reloadTime == 14 && (itemSelected.substring(0,itemSelected.length-2) == "yes:remington870" || itemSelected.substring(0,itemSelected.length) == "yes:empty_remington870" || itemSelected.substring(0,itemSelected.length-2) == "yes:ithaca37" || itemSelected.substring(0,itemSelected.length) == "yes:empty_ithaca37")) { player.runCommand(`playsound gun.yes.remington870_reload @s `); }
        //} catch {}
    }, 0);
    const throwLoop = system.runInterval(() => {
        try { player.name }
        catch { system.clearRun(throwLoop); return; }

        try { var reloadTime = world.scoreboard.getObjective("reload_timer").getScore(player); }
        catch {
            player.runCommandAsync(`scoreboard objectives add reload_timer dummy`); 
            player.runCommandAsync(`scoreboard players random @s reload_timer -1`); 
            var identifier = world.scoreboard.getObjective("identifier").getScore(player);
        }
        if(reloadTime >= 0) { reloadFinished = 0; }
        //else { reloadFinished = true; }

        if(reloadTime >= 0) { player.runCommand(`title @s actionbar §l§e<§r§7Reload: §a[${Math.round(reloadTime/2)/10}]§e§l>`); }
        else if(reloadTime == -1 && player.runCommand(`testfor @s[tag=cancelled]`).successCount == 1) { 
            player.runCommand(`title @s actionbar §l§e<§r§7Reload: §cCancelled§e§l>`);
            //stopSound(player);
            player.runCommand(`tag @s remove cancelled`); reloadFinished = 2; 
        }
        else if(reloadTime == -1 && reloadFinished == 1) { player.runCommand(`title @s actionbar §l§e<§r§7Reload: §aFinished§e§l>`); reloadFinished = 2; }
        else if(reloadTime == -1 && reloadFinished == 0) { player.runCommand(`title @s actionbar §l§e<§r§7Reload: §a[0.0]§e§l>`); reloadFinished = 1; }
        
        player.runCommand(`scoreboard players set @s scoped 0`);
        try {
            var essential     = player.getComponent('minecraft:inventory').container;
            var itemSlot      = essential.getSlot(player.selectedSlot);
            var itemSelected  = itemSlot.getItem().typeId;

            if(usingJavelin == true && ((itemSelected != "yes:javelin" && itemSelected != "yes:empty_javelin") || player.isSneaking == false)) {
                player.removeEffect(EffectTypes.get('night_vision'));
                player.addEffect(EffectTypes.get('night_vision'), 4, { amplifier: 1, showParticles: false });
                usingJavelin = false;
                //console.warn(`removed; sneaking: ${player.isSneaking}, using: ${usingJavelin}`);
            }
        } catch {}

        try { if (!player.isSneaking) return; }
        catch { system.clearRun(throwLoop); return; }
        
        try {
            var essential     = player.getComponent('minecraft:inventory').container;
            var itemSlot      = essential.getSlot(player.selectedSlot);
            var itemSelected  = itemSlot.getItem().typeId;

            if(itemSelected.substring(0,16) == "yes:remington870") {
                itemSelected = "yes:remington870";
            }
            else if(itemSelected.substring(0,12) == "yes:ithaca37") {
                itemSelected = "yes:ithaca37";
            }
            if (throwables[itemSelected]) {
                const slowAmplifier = throwables[itemSelected].scope.slowness;
                const speedAmplifier = throwables[itemSelected].scope.speed;
                if(itemSelected != "yes:mk13") {
                    player.addEffect(EffectTypes.get('speed'), 5, { amplifier: speedAmplifier, showParticles: false });
                    player.addEffect(EffectTypes.get('slowness'), 5, { amplifier: slowAmplifier, showParticles: false });
                }
                else {
                    var sniperScore = world.scoreboard.getObjective("sniper_scope").getScore(player);
                    if(sniperScore == -1) {
                        player.addEffect(EffectTypes.get('speed'), 5, { amplifier: throwables[itemSelected].scope.speed1, showParticles: false });
                        player.addEffect(EffectTypes.get('slowness'), 5, { amplifier: throwables[itemSelected].scope.slowness1, showParticles: false });
                    }
                    else if(sniperScore == 0) {
                        player.addEffect(EffectTypes.get('speed'), 5, { amplifier: throwables[itemSelected].scope.speed2, showParticles: false });
                        player.addEffect(EffectTypes.get('slowness'), 5, { amplifier: throwables[itemSelected].scope.slowness2, showParticles: false });
                    }
                }
                if(itemSelected == "yes:javelin") {
                    player.addEffect(EffectTypes.get('night_vision'), 2000, { amplifier: 1, showParticles: false });
                    usingJavelin = true;
                }
                player.runCommand(`scoreboard players set @s scoped 1`);
            }
            else if (emptyThrowables[itemSelected]) {
                const slowAmplifier = emptyThrowables[itemSelected].scope.slowness;
                const speedAmplifier = emptyThrowables[itemSelected].scope.speed;
                if(itemSelected != "yes:empty_mk13") {
                    player.addEffect(EffectTypes.get('speed'), 5, { amplifier: speedAmplifier, showParticles: false });
                    player.addEffect(EffectTypes.get('slowness'), 5, { amplifier: slowAmplifier, showParticles: false });
                }
                else {
                    var sniperScore = world.scoreboard.getObjective("sniper_scope").getScore(player);
                    if(sniperScore == -1) {
                        player.addEffect(EffectTypes.get('speed'), 5, { amplifier: emptyThrowables[itemSelected].scope.speed1, showParticles: false });
                        player.addEffect(EffectTypes.get('slowness'), 5, { amplifier: emptyThrowables[itemSelected].scope.slowness1, showParticles: false });
                    }
                    else if(sniperScore == 0) {
                        player.addEffect(EffectTypes.get('speed'), 5, { amplifier: emptyThrowables[itemSelected].scope.speed2, showParticles: false });
                        player.addEffect(EffectTypes.get('slowness'), 5, { amplifier: emptyThrowables[itemSelected].scope.slowness2, showParticles: false });
                    }
                }
                if(itemSelected == "yes:empty_javelin") {
                    player.addEffect(EffectTypes.get('night_vision'), 2000, { amplifier: 1, showParticles: false });
                    usingJavelin = true;
                }
                player.runCommand(`scoreboard players set @s scoped 1`);
            }
        } catch {}
    }, 2);
}
//function stopSound(player) {
//    player.runCommand(`stopsound @s gun.yes.ak47_reload`); 
//    player.runCommand(`stopsound @s gun.yes.ar15_reload`); 
//    player.runCommand(`stopsound @s gun.yes.p90_reload`); 
//    player.runCommand(`stopsound @s gun.yes.desert_eagle_reload`); 
//    player.runCommand(`stopsound @s gun.yes.mk13_reload`); 
//    player.runCommand(`stopsound @s gun.yes.remington870_reload`); 
//    player.runCommand(`stopsound @s gun.yes.rpg7_reload`); 
//}




world.afterEvents.entitySpawn.subscribe(async (eventData) => {
    const entity = eventData.entity;
    if(entity.typeId == "yes:mgl105_grenade_dummy3") {
        entity.runCommand(`scoreboard players operation @s identifier2 = @e[type=yes:mgl105_grenade_dummy2,c=1,r=5] identifier2`);
        //entity.runCommand(`say loaded`);
        var identifier = world.scoreboard.getObjective("identifier2").getScore(entity);
        entity.runCommandAsync(`structure load grenade_bottom_${identifier} ~-4~-4~-4`);
        entity.runCommandAsync(`structure load grenade_top_${identifier} ~-4~1~-4`);
        //entity.runCommand(`say ${identifier}`);
    }
    else if(entity.typeId == "yes:javelin_missile") {
        const height = entity.location.y;
        var speed = 0.15;
        var elevation = height+500;
        var goingDown = false;
        //entity.runCommand(`tp @s ~~~ facing @p`);
        //entity.runCommand(`tp @s ~~~ ~180 ~`);

        const throwLoop = system.runInterval(() => {
            //console.warn(entity.location);
            try { entity.location }
            catch { system.clearRun(throwLoop); return; }
            var identifier2 = world.scoreboard.getObjective("identifier2").getScore(entity);
            //try { var identifier2 = entity.scoreboardIdentity.getScore(world.scoreboard.getObjective("identifier2")); }
            //catch { var identifier2 = 0; }

                //console.warn(otherEntityLocation.z);
            //entity.runCommand(`tp @s ~~~ facing @p`);
            try { var score = world.scoreboard.getObjective("timer").getScore(entity); }
            catch { var score = 0; }

            const otherEntity = entity.dimension.getEntities({families:["javelin_lock"], scoreOptions:[{objective: "identifier2", maxScore: identifier2, minScore: identifier2}]})[0];
            //const otherEntity = entity.dimension.getEntities({closest: 1, type: "minecraft:player"})[0];
                //const test =        entity.dimension.getEntities({families:["javelin_lock"], scoreOptions:[{objective: "identifier2", maxScore: identifier2, minScore: identifier2}]});
                //try {var test1 = test[0].typeId} catch {var test1 = "none"}
                //try {var test2 = test[1].typeId} catch {var test2 = "none"}
                //try {var test3 = test[2].typeId} catch {var test3 = "none"}
                //try {var test4 = test[3].typeId} catch {var test4 = "none"}
            //console.warn(`${test1} ${test2} ${test3} ${test4}`);
            //console.warn(`${identifier2}`);
            let entityLocation = entity.location;
            let otherEntityLocation;
            try { otherEntityLocation = otherEntity.location; }
            catch { otherEntityLocation = entity.location }
            

            if(score >= 20) {
                entity.runCommand(`particle yes:javelin_smoke_trail ~~~`);
                entity.runCommand(`fill ~~-1~ ~~-1~ yes:muzzle_flash_light replace air`);
                var random = randomNum(1,2);
                if(random <= 1.4) {
                    entity.runCommand(`particle yes:javelin_flash ~~~`);
                }
                if(score == 20) {
                    entity.runCommand(`summon yes:javelin_knockback`);
                }
                if(score == 22) {
                    entity.runCommand(`particle yes:javelin_blast ~~-0.6~`);
                    entity.runCommand(`camerashake add @a[r=35] 0.15 0.2 rotational`);
                    entity.runCommand(`camerashake add @a[r=35] 0.006 3 rotational`);
                    entity.runCommand(`camerashake add @a[r=35] 0.008 8 rotational`);
                    entity.runCommand(`particle yes:muzzle_flash ~~~`);
                    entity.runCommand(`fill ~~~ ~~-4~ yes:muzzle_flash_light replace air`);
                }
                var range = entityLocation.y+10-otherEntityLocation.y;
                if(range < 0) { range = 0; }
                    //console.warn(`range: ${range}, height: ${entityLocation.y}, elevation: ${elevation}`);
                //entity.runCommand(`say locat: ${entityLocation.y}, other: ${otherEntityLocation.y}`);
                if(entity.runCommand(`testfor @e[family=javelin_lock,scores={identifier2=${identifier2}},r=${range}]`).successCount == 1 || goingDown == true) {
                //if(entity.runCommand(`testfor @e[type=minecraft:player,r=${entityLocation.y+30-otherEntityLocation.y}]`).successCount == 1 || goingDown == true) {
                    entity.teleport({x:entityLocation.x, y:entityLocation.y, z:entityLocation.z}, {keepVelocity:false, facingLocation:{x:otherEntityLocation.x, y:otherEntityLocation.y, z:otherEntityLocation.z}});
                    goingDown = true;
                }
                else {
                    entity.teleport({x:entityLocation.x, y:entityLocation.y, z:entityLocation.z}, {keepVelocity:false, facingLocation:{x:otherEntityLocation.x, y:elevation, z:otherEntityLocation.z}});
                    if(elevation > height+100) {
                        elevation=elevation-6;
                    }
                }

                
                let viewVector = entity.getViewDirection();
                
                entity.clearVelocity();
                entity.applyImpulse(new Vector(viewVector.x*speed, viewVector.y*speed, viewVector.z*speed));
                if(speed < 3) { speed = speed+((3.05-speed)/23); }
                else { speed = 3; }

                if(entity.runCommand(`testfor @e[family=javelin_lock,scores={identifier2=${identifier2}},r=2]`).successCount == 1) {
                    entity.runCommand(`event entity @s yes:on_hit`);
                    //console.warn(`success`);
                }
            }
            else if(score > 0) {
                entity.runCommand(`tp @s ~~~ facing @e[type=yes:javelin_look,c=1,scores={identifier2=${identifier2}}]`);
                //entity.teleport({x:entityLocation.x, y:entityLocation.y, z:entityLocation.z}, {keepVelocity:false, facingLocation:{x:otherEntityLocation.x, y:otherEntityLocation.y, z:otherEntityLocation.z}});
                let viewVector = entity.getViewDirection();
                entity.clearVelocity();
                entity.applyImpulse(new Vector(viewVector.x*0.5, viewVector.y*0.5, viewVector.z*0.5));
            }
            else {
                let viewVector = entity.getViewDirection();
                entity.clearVelocity();
                entity.applyImpulse(new Vector(viewVector.x*0.5, viewVector.y*0.5, viewVector.z*0.5));
            }
            //entity.runCommand(`scoreboard players operation @s identifier2 = @e[type=yes:mgl105_grenade_dummy2,c=1,r=5] identifier2`);
            //entity.runCommand(`say loaded`);
            //var identifier = entity.scoreboardIdentity.getScore(world.scoreboard.getObjective("identifier2"));
            //entity.runCommandAsync(`structure load grenade_bottom_${identifier} ~-4~-4~-4`);
            //entity.runCommandAsync(`structure load grenade_top_${identifier} ~-4~1~-4`);
            //entity.runCommand(`say ${identifier}`);
        }, 0);
    }
    else if(entity.typeId == "yes:javelin_target_lock_projectile") {
        const throwLoop = system.runInterval( () => {
            try { entity.location }
            catch { system.clearRun(throwLoop); return; }
            try {
                if(entity.getTags()[0] == "hit") {
                    javelin_projectile_tp(entity);
                    system.clearRun(throwLoop); 
                    //console.warn(`hihi`);
                    return;
                }
            } catch { entity.remove(); }
        }, 0);
    }
    else if(entity.typeId == "yes:player_entity") {
        const throwLoop = system.runInterval( () => {
            try { entity.location }
            catch { system.clearRun(throwLoop); return; }

            entity.runCommand(`scoreboard players set @s despawn 2`);
            try {
                var identifier = world.scoreboard.getObjective("identifier").getScore(entity);
                const { x, y, z } = entity.location;
                if(entity.dimension.getEntities({type:"minecraft:player", location:{x:x, y:y, z:z}, minDistance:3.7, scoreOptions:[{objective: "identifier", maxScore: identifier, minScore: identifier}]})[0]) {
                    entity.runCommand(`tp @s @e[type=player,scores={identifier=${identifier}},c=1]`);
                    //console.warn("1");
                }
                else if(entity.runCommand(`testfor @a[scores={identifier=${identifier}},rm=3.7]`).successCount == 1) {
                    entity.runCommand(`tp @s @e[type=player,scores={identifier=${identifier}},c=1]`);
                }
                if(entity.runCommand(`testfor @a[scores={identifier=${identifier}}]`).successCount == 0) {
                    //R*Econsole.warn("Entity removed: no player with same id");
                    entity.remove();
                }
                else if(entity.runCommand(`testfor @e[type=yes:player_entity,rm=1,scores={identifier=${identifier}}]`).successCount == 1) {
                    entity.remove();
                }
            }
            catch {
                //R*Econsole.warn("Entity removed: catch");
                entity.remove();
            }
        }, 0);
    }
});

function javelin_projectile_tp(entity) {
    var identifier = world.scoreboard.getObjective("identifier").getScore(entity);

    if(entity.runCommand(`testfor @s[tag=no_target]`).successCount == 1) {
        entity.runCommand(`tellraw @a[scores={identifier=${identifier}}] {"rawtext":[{"text":"§7Javelin: §c[no entity to lock on]"}]}`);
        entity.kill();
        return;
    }
    else {
        entity.runCommand(`tellraw @a[scores={identifier=${identifier}}] {"rawtext":[{"text":"§7Javelin: §a[target locked]"}]}`);
    }

    const throwLoop = system.runInterval(() => {
        
        try { entity.location }
        catch { system.clearRun(throwLoop); return; }
        var identifier = world.scoreboard.getObjective("identifier").getScore(entity);
        const identifier2 = world.scoreboard.getObjective("identifier2").getScore(entity);
        entity.runCommand(`tp @s ^^^0.285 facing @e[r=6,type=!yes:javelin_target_lock_projectile,scores={identifier3=${identifier2}}]`);
        var missileQ = entity.runCommand(`testfor @e[type=yes:javelin_missile,scores={identifier2=${identifier2}}]`).successCount;
        //if((entity.runCommand(`testfor @e[r=6,type=!yes:javelin_target_lock_projectile,scores={identifier3=${identifier2}}]`).successCount == 0 && missileQ == 0) || (entity.runCommand(`testfor @a[scores={identifier2=${identifier2}},hasitem={item=yes:javelin,location=slot.weapon.mainhand}]`).successCount == 0 && missileQ == 0)) {
        
        if((entity.runCommand(`testfor @e[r=6,type=!yes:javelin_target_lock_projectile,scores={identifier3=${identifier2}}]`).successCount == 0 && missileQ == 0)) {
            entity.runCommand(`scoreboard players reset @e[scores={identifier3=${identifier2}}] identifier3`);
            entity.runCommand(`tellraw @a[scores={identifier=${identifier}}] {"rawtext":[{"text":"§7Javelin: §c[target lost]"}]}`);
            //console.warn(`entity killed`);
            entity.kill();
        }
        try {
            if(entity.runCommand(`testfor @e[type=yes:javelin_missile,scores={identifier2=${identifier2}}]`).successCount == 0 && entity.runCommand(`testfor @s[tag=fired]`).successCount == 1) {
                entity.kill();
            }
            else if((entity.runCommand(`testfor @s[tag=kill]`).successCount == 1) && entity.runCommand(`testfor @e[type=yes:javelin_missile,scores={identifier2=${identifier2}}]`).successCount == 0) {
                entity.kill();
            }
        } catch {}
    }, 0);
}


}
catch{
        world.afterEvents.playerSpawn.subscribe(async (eventData) => {
            var player = eventData.player;
            var times = 0;
            
            const throwLoop = system.runInterval(() => {
                var { x, y, z } = player.getVelocity();
                //console.warn("final: "+x+" "+y+" "+z);
                if(x!=0 || y!=0 || z!=0 || times!=0) {
                    if(times == 0) {
                        player.runCommand(`tellraw @a {"rawtext":[{"text":"------------------------------"}]}`);
                        player.runCommand(`tellraw @a {"rawtext":[{"text":"§c§lSomething went wrong with the mod, please download the latest version!!"}]}`);
                        player.runCommand(`tellraw @a {"rawtext":[{"text":"------------------------------"}]}`);
                    }
                    if(times <= 2) {
                        player.runCommand(`playsound note.bell @a ~~1~ 1 0.035 1`);
                        player.runCommand(`playsound note.bell @a ~~1~ 1 0.035 1`);
                    }
                    times++;
                    if(times >= 8) {
                        player.runCommand(`tellraw @a {"rawtext":[{"text":"------------------------------"}]}`);
                        player.runCommand(`tellraw @a {"rawtext":[{"text":"Go to §7(§ahttps://mcpedl.com/user/WeeweeJuice/§7) §rto download the newest update!"}]}`);
                        player.runCommand(`tellraw @a {"rawtext":[{"text":"               ----------"}]}`);
                        player.runCommand(`tellraw @a {"rawtext":[{"text":"If this is the newest version of the mod, message me on our Discord Server! §7(§bhttps://discord.gg/dbg8m4zSnK§7)"}]}`);
                        player.runCommand(`tellraw @a {"rawtext":[{"text":"------------------------------"}]}`);
                        player.runCommand(`playsound note.harp @a ~~1~ 1 4 1`);
                        system.clearRun(throwLoop);
                    }
                }
            }, 10);
        });
}

//tellraw @a {"rawtext":[{"text":"------------------------------"}]}
//tellraw @a {"rawtext":[{"text":"Go to \n§a(https://mcpedl.com/user/WeeweeJuice/)\n§rto download the newest update!"}]}
//tellraw @a {"rawtext":[{"text":"------------------------------"}]}
//tellraw @a {"rawtext":[{"text":"If this is the newest version of the mod, message me on our Discord Server! \n(§bhttps://discord.gg/dbg8m4zSnK)"}]}
//tellraw @a {"rawtext":[{"text":"------------------------------"}]}
//tellraw @a {"rawtext":[{"text":"§c§lSomething went wrong with the mod, please download the latest version!!"}]}
//
//tellraw @a {"rawtext":[{"text":"               ----------"}]}

//tellraw @a {"rawtext":[{"text":"------------------------------"}]}
//tellraw @a {"rawtext":[{"text":"§c§lSomething went wrong with the mod, please download the latest version!!"}]}
//tellraw @a {"rawtext":[{"text":"------------------------------"}]}
//tellraw @s {"rawtext":[{"text":"§7Javelin: §c[target lost]"}]}
//world.events.explosion.subscribe(async (eventData) => {
//    const entity = eventData.source;
//    entity.runCommand(`say  loaded`);
//    if(entity.typeId != "yes:mgl105_grenade_dummy3") return;
//    
//    //entity.runCommand(`say ${identifier}`);
//    entity.runCommand(`say  loaded`);
//    var identifier = entity.scoreboard.getScore(world.scoreboard.getObjective("identifier2"));
//    entity.runCommand(`say ${identifier} loaded`);
//    entity.runCommandAsync(`structure load grenade_bottom_${identifier} ~-5~-6~-5`);
//    entity.runCommandAsync(`structure load grenade_top_${identifier} ~-5~1~-5`);
//    //entity.runCommand(`say ${identifier}`);
//
//});



//for gun:: /////////////////////////////////////////////////////////
//scoreboard objectives add bullet_score dummy
//tag @e[family=bullet,scores={bullet=0}] add start_dmg
//OR
//scoreboard players add @e[family=bullet,scores={bullet=0..2}] bullet 1
//tag @e[family=bullet,scores={bullet=2}] add start_dmg



//for projectile file:: /////////////////////////////////////////////////////////////////
//[projectile component] into <component groups>

//on spawn:   add <projectile no on_hit>

//after detecting 'start_dmg' tag:   add <projectile yes on_hit> remove <projectile no on_hit>



//if doesn't hit entities for extended range (if it doesnt work):: //////////////////////////////////////////
//make initial velocity very slow
//add velocity to bullet file

//world.events.DataDrivenEntityTrigger.subscribe(async (eventData) => {
//    const entity = eventData.entity;
//    const entityId = eventData.entity.typeId;
//    const event = eventData.id;
//    if(!bullets[entityId]) return;
//    if(event != 'yes:start_dmg') return;
//
//	let viewVector = projectile.getViewDirection();
//    const projectileRotation = projectile.getRotation();
//    if (projectileRotation.x > 30) {
//        viewVector.x *= 2.1;
//        viewVector.y *= 2.1;
//        viewVector.z *= 2.1;
//    }
//    projectile.applyImpulse(new Vector(viewVector.x * bullets[entityId].velocity, viewVector.y * throwables[entityId].velocity, viewVector.z * throwables[entityId].velocity));
//});
















//other stuff

//world.events.DataDrivenEntityTrigger.subscribe(async (eventData) => {
//    const entity = eventData.entity;
//    const event = eventData.id;
//    if(!bullets[entity.typeId]) return;
//    if(event != 'yes:on_hit') return;
//    eventData.damage = 0;
//
//
//    eventData.setModifiers(getComponentGroupsToAdd('yes:test'));
//
//
//
//
//
//
//
//
//
//    //source.runCommandAsync(`say hi`);
//    var health = target.getComponent('health').current;
//    var damage = bullets[projectile.typeId].damage;
//
//    const testfor1 = target.runCommand(`testfor @s[m=c]`).successCount;
//    if (testfor1 == 1) return;
//
//    if (typeof target.scoreboard.getScore(world.scoreboard.getObjective("identifier")) === void 0) {
//        target.getComponent('health').setCurrent(health-damage);
//        target.runCommandAsync('damage @s 0 override');
//        projectile.runCommandAsync('say is nan');
//    }
//    else {
//    const targetIdentifier = target.scoreboard.getScore(world.scoreboard.getObjective("identifier"));
//    const projectileIdentifier = projectile.scoreboard.getScore(world.scoreboard.getObjective("identifier"));
//    //target.runCommandAsync(`say PROJECTILE ${projectile}`);
//
//        if (targetIdentifier != projectileIdentifier) {
//            target.getComponent('health').setCurrent(health-damage);
//            target.runCommandAsync(`damage @s 0 override`);
//            projectile.runCommandAsync(`say hit wid`);
//        }
//    }
//});


//Player.prototype.updateDamage = function () {
//    const { prevHp } = this
//    let { current, value } = this.getComponent('health')
//    if (typeof prevHp == 'number') value = prevHp
//    this['prevHp'] = current
//    return value - current
//  }
//  Entity.prototype.updateDamage = function () {
//    const { prevHp } = this
//    let { current, value } = this.getComponent('health')
//    if (typeof prevHp == 'number') value = prevHp
//    this['prevHp'] = current
//    return value - current
//  }
//  
//  world.events.entityHurt.subscribe((data) => {
//    var Player = events.hurtEntity;
//    const { damage, hurtEntity } = data
//    const takenDamage = hurtEntity.updateDamage()
//    console.warn(JSON.stringify({damage,takenDamage},0,3))
//  })
